// cap0501.cpp
// Trabajo con funciones

#include <iostream>
using namespace std;
int ej0501max(int, int);
void ej0502ordena(int &,  int &);
int ej0503matriz(int *,  int);

// const nos asegura que el parmetro no se modificar
// en la funcin (al menos, utilizando ese puntero)
int ej0504cadena(const char *,  char);
char * ej0504cadena2(char [],  char);

struct persona
{
	int   numemp;
	long  dni;		
};
persona ej0505struct(const persona);
persona & ej0506struct(persona &);
int & ej0506struct(int &);



int main()
{
// llamada a las funciones de los ejercicios del captulo 5

	cout << "cap501.cpp ejemplos cap. 5 \n\n";
	int i = ej0501max(3, 7);
	cout << "Valor mayor es " << i << "\n";

	int m = 8;
	int k = 6;
	cout << "Valores originales " << m << k << "\n\n";
    ej0502ordena(m, k);
	cout << "Valores ordenados " << m << k << "\n\n";


	//**********************

	int mat[5] = {2, 4, 6, 8, 1};
	int cant = 5;
	// atencin: mat es un puntero, por lo que
	// la matriz se pasa por referencia
	// esto implica que podemos modificarla
	// en la funcin (salvo que sea declarada como const)
    int menor = ej0503matriz(mat, cant); 
    cout << "1. El valor menor es " << menor << "\n\n";
	cout << " . Tamao " << sizeof(mat) << "\n\n";
	cout << " . Tamao " << sizeof(mat[0]) << "\n\n";

	menor = ej0503matriz(mat, cant); 
    cout << "2. El valor menor es " << menor << "\n\n";

	//**********************

	// Definimos la cadena como un puntero a chr
	char * texto1 = "Curso de programacin C++";
	// Funcin busca la primera aparicin del carcter p
	// devuelve la posicin del carcter en el texto
	// 0 significa que no encontr el carcter
	int pos = ej0504cadena(texto1,'p');
	cout << "Caso 1: La letra p aparece en pos. " << pos << "\n\n";

	// Definimos la cadena como una matriz de texto
	char texto2[] = "Otra posibilidad para informar una cadena";
	// Nueva bsqueda
	// La llamada es similar al caso anterior
    pos = ej0504cadena(texto2,'p');
	cout << "Caso 2: La letra p aparece en pos. " << pos << "\n\n";

	// Nueva bsqueda
	// buscamos un carcter que no est en la cadena
    pos = ej0504cadena(texto2,'H');
	if (pos == 0)
	    cout << "Caso 3: La letra H no aparece en la cadena\n\n";

	//**********************

	// Cmo se recibe una cadena desde una funcin?
	char * texto3 = ej0504cadena2(texto2,'H');
	cout << "Caso 4: Devuelve una cadena como puntero: " << texto3 << "\n\n";

	//**********************

	// argumentos y retornos de estructuras
	// p1 es estructura argumento
	// p2 es valor de retorno
	persona p1 ={0, 23400000};
	persona p2 = ej0505struct(p1);
	cout << "Asigna nro. empleado: " << p2.numemp << "\n\n";

	p1.dni =33300000;
	p2 = ej0505struct(p1);
	cout << "Asigna nro. empleado: " << p2.numemp << "\n\n";

	//**********************

	// retorno de referencia a estructura
    persona p3 ={4, 8888888};
	cout << "Antes\n";
	cout << "p1.numemp : " << p1.numemp << "\n";
	cout << "p1.dni    : " << p1.dni << "\n\n";
	cout << "p3.numemp : " << p3.numemp << "\n";
	cout << "p3.dni    : " << p3.dni << "\n\n";

	// se asigna una estructura a una funcin?
    ej0506struct(p1) = p3;

	// debido a que la referencia devuelta por la funcin
	// es la referencia a p1
	// esto es equivalente a lo anterior
	ej0506struct(p1);
	p1 = p3;
	 

	cout << "Despus de la asignacin a una funcin\n";
	cout << "p1.numemp : " << p1.numemp << "\n";
	cout << "p1.dni    : " << p1.dni << "\n\n";
	cout << "p3.numemp : " << p3.numemp << "\n";
	cout << "p3.dni    : " << p3.dni << "\n\n";
	 
	int x = 55;
	int y = 77;
    ej0506struct(x) = y;
	cout << "Despus de la asignacin a una funcin\n";
	cout << "x era 55: " << x << "\n";
	cout << "y era 77: " << y << "\n\n";
	 
	
	int j;
	cin >> j;
	return 0;
}
int ej0501max(int x, int y)
{
	// devuelve el valor mximo
	cout << "Func. ej0501max \n\n";
	if (x > y)
		return x;
	else
		return y;
} 
void ej0502ordena(int &n1, int &n2)
{
	// ordena dos valores de menor a mayor
	cout << "Func. ej0502ordena \n\n";
	int temp;
	if (n1 > n2)
	{
		temp = n2;
		n2 = n1;
		n1 = temp;
	}
	 
} 
int ej0503matriz(int mat[], int n)
{
	// busca el valor menor de una matriz

	cout << "Func. ej0503matriz \n\n";
	int temp = mat[0]; 
	for (int i = 1; i < n; i++)
	{
	if (mat[i] < temp)
		temp = mat[i];
	}
	// Modifico la matriz
	// para la siguiente llamada a esta funcin
	mat[3]= 0;

	// en temp queda el valor menor del proceso
	return temp;
	 
}
// Estas dos declaraciones son vlidas y equivalentes
//int ej0504cadena(const char  * cadena, char chr)
int ej0504cadena(const char  cadena[], char chr)
{
	// busca la primera aparicin
	// del carcter chr

	cout << "Func. ej0504cadena \n\n";

	// El bucle se ejecuta hasta encontrar
	// ASCII 0 (false)
	for (int i = 1; *cadena; i++)
	{
		// *cadena tiene el valor apuntado por el puntero
		if (*cadena == chr)  
			return i;   // se devuelve la posicin de la 
						// primera aparicin
		// incremento el puntero en 1 posicin char
		cadena++;
	}  
	// si no se detecta el carcter, se devuelve 0
	return 0; 
	 
} 

char * ej0504cadena2(char  cadena[], char chr)
{
	// Valor de retorno: una cadena
	return "Hola cadena";
}
persona ej0505struct(persona p1)
{
	persona temp;
	// Numera a partir de 80
	static int x = 80;

	// copia los datos de una estructura a otra
	temp = p1;

	// asigna nmero de empleado
	// y lo incrementa en la variable esttica
	temp.numemp = x++;
 	
	// devuelve la estructura resultante
	return temp;
}
persona & ej0506struct(persona & x1)
{
	x1.numemp = 7;	 
	return x1;
}
int & ej0506struct(int & x1)
{
	x1 = 7;	 
	return x1;
}


 


