// Archivo cap0701.cpp
// Ejemplo de uso de clases
// Generacin de instancias
// Anlisis de constructores y destructores
//
#include <iostream>
#include "cempleado.h"
using namespace std;
void test_clases();
void test2();
int main()
{
	cout << "*****************************************\n";
	cout << "Programa cap07: Ejemplo del uso de clases\n";
    cout << "*****************************************\n\n";
	test_clases();
	test2();

	int final;
	cin >> final;
}
void test2()
{
	cout << "Se va a crear el objeto Empleado XXX\n";
	Empleado *emp2 = new Empleado("XXXX", 50, 35.50);
	//delete emp2;
}
void test_clases()
{

	// Variantes de creacin de ejemplares de una clase

	// Uso de constructores para crear un objeto Empleado
	cout << "Se va a crear el objeto Empleado de Carlos Salas\n";
	// Forma compacta
	Empleado emp1("Carlos Salas", 20, 25.50);

	// Otro modo de creacin: Memoria dinmica, operador new
	cout << "Se va a crear el objeto Empleado de Ernesto Castro\n";
	Empleado *emp2 = new Empleado("Ernesto Castro", 50, 35.50);

	// Otro modo de creacin: ms explcita
	cout << "Se va a crear el objeto Empleado de Juana Miller\n";
	Empleado emp3 = Empleado("Juana Miller", 10, 33.00);

	// Uso de los mtodos de un objeto
	// Vemos el estado de un objeto
	emp1.mostrarTotalDebido();

	// Se actualizan las horas trabajadas
	emp1.modificarHorasTrabajadas(20);

	// Cmo queda el objeto?
	emp1.mostrarTotalDebido();

	// Reasignacin de valores en el objeto emp1
	// Se reutiliza el objeto emp1
	cout << "Se va a reasignar el objeto Empleado de Carlos Salas con Juan Morel\n";

	// Esta operacin implica la creacin de un objeto temporal
	// que se destruye despus de la asignacin
	emp1 = Empleado("Juan Morel", 5, 15.50);

	// Cmo queda el objeto?
	emp1.mostrarTotalDebido();

	// Asignacin de un objeto a otro
	// copia de objetos
	cout << "Se copian los datos de Juana Miller en Juan Morel\n\n";
	cout << "Ahora los datos de Juana Miller aparecen en dos objetos\n\n";
	emp1 = emp3;

	// En los datos apuntados por emp2 (memoria dinmica)
	// asignamos los datos de Juana Miller
	// se utiliza -> ya que trabajamos con un puntero
	// al objeto emp2
	cout << "Acceso al objeto en memoria dinamica \n\n";
    emp2->mostrarTotalDebido();
	*emp2 =  emp3;

	// Cmo queda el objeto?
	emp1.mostrarTotalDebido();

	// Se deben destruir todos los objetos
	// creado en este bloque
	// salvo el creado con el operador new
	cout << "Ahora veremos los objetos que quedan por destruir\n";
	cout << "*** emp2 (Ernesto Castro) no se destruye porque se ha creado "
			<< "con el operador new\n\n";

	cout << "Uso del puntero this\n\n";
	// Uso del puntero this
	Empleado empx = emp1.maxValorHora(emp3);

	empx.mostrarTotalDebido();

	Empleado emps[10];

	// Uso de un elemento de la matriz de clase Empleado
	cout << "Uso de matrices de objetos \n\n";
	emps[0].mostrarTotalDebido();


	// Inicializar los objetos con el constructor
	// con argumentos
	Empleado emps2[6] = {
		Empleado("Juan Santos", 4, 5.0),
		Empleado("Mercedes Negri", 6, 10.6),
		Empleado("Ignacio Apo", 8, 12.50),
		Empleado("Enrique Gates", 4, 21.0),
		Empleado("Susana Paolini", 5, 11.6),
		Empleado("Elsa Belgrano", 4, 9.0),
	};
	cout << "Constructor con argumentos en matriz de objetos \n\n";
	emps2[2].mostrarTotalDebido();

	Empleado mayorValorHora = emps2[0];
	for (int i = 1; i < 6; i++)
		mayorValorHora = mayorValorHora.maxValorHora(emps2[i]);

	// El empleado con mayor valor hora es:
	mayorValorHora.mostrarTotalDebido();

	// Const
	cout << "Uso de miembros const\n\n";
	const Empleado emp5 = Empleado("Leonardo Astrada", 5, 12.5);
    Empleado emp6 = Empleado("Juan Miller", 9, 11.85);

	emp5.mostrarTotalDebido();
	emp6.mostrarTotalDebido();

	Empleado emp7 = emp6.maxValorHora(emp5);
	emp7.mostrarTotalDebido();
	emp7.modificarHorasTrabajadas(20);

	emp5.mostrarTotalDebido();
	emp7.mostrarTotalDebido();

cout << "Borrado del objeto creado con new\n";
delete emp2;


}

