#include "cHora.h"
#include <iostream>
using namespace std;

Hora::Hora()
{
	// Inicializa sin valores
	horas = 0;
	minutos = 0;
	segundos = 0;
}
Hora::Hora(int h, int m, int s)
{
	// Inicializa con valores
	horas = h;
	minutos = m;
	segundos = s;	
}

void Hora::sumar(int h, int m, int s) 
{
	// Suma horas, minutos y segundos
	// en el objeto Hora
	horas += h;
	minutos += m;
	segundos += s;
}

void Hora::sumar(const Hora & h) 
{
	// Suma de dos objetos Hora
	// con la sintaxis
	// x1.sumar(x2);
	//Hora nHora;
	horas += h.horas;
	minutos += h.minutos;
	segundos += h.segundos;
}

void Hora::Listar() 
{
	// Cada vez que lista el objeto
	// corrige los valores de 
	// horas, minutos y segundos
	// para que minutos y segundos no superen 
	// el valor de 60
	ajustar60();

	cout << "HH::MM:SS  = " << horas << ":" << minutos << ":" << segundos << "\n\n";  
}
void Hora::ajustar60()
{
	// Ajusta que los datos miembros
	// minutos y segundos no excedan
	// de 60
	minutos += segundos / 60;
	segundos %= 60;
	horas += minutos / 60;
	minutos %= 60;
}
Hora Hora::operator+(const Hora & h) const
{
	// Suma de dos objetos Hora
	// con la sintaxis
	// x1 = x2 + x3;
	Hora nHora;
	nHora.horas = horas + h.horas;
	nHora.minutos = minutos + h.minutos;
	nHora.segundos = segundos + h.segundos;
	return nHora;

}
Hora Hora::operator*(long q) const
{
	// multiplica el objeto Hora
	// por un valor long
	// x1 = x2 * q;
	Hora nHora;
	long qsegundos;
	qsegundos = horas * 3600 + minutos * 60 + segundos;
	qsegundos *= q;
	nHora.horas = qsegundos / 3600;
	nHora.segundos = qsegundos % 3600; 
	nHora.minutos = nHora.segundos / 60;
	nHora.segundos -= (nHora.minutos * 60); 
	return nHora;
}

Hora  operator*(long q, const Hora & h)  
{
	// multiplica el objeto Hora
	// por un valor long
	// x1 = q * x2;
	Hora nHora;
	long qsegundos;
	qsegundos = h.horas * 3600 + h.minutos * 60 + h.segundos;
	qsegundos *= q;
	nHora.horas = qsegundos / 3600;
	nHora.segundos = qsegundos % 3600; 
	nHora.minutos = nHora.segundos / 60;
	nHora.segundos -= (nHora.minutos * 60); 
	return nHora;
}
Hora::operator int() const
{
	// la conversin a int devuelve el valor
	// de la hora en segundos
	return horas * 3600 + minutos * 60 + segundos;
}
Hora::operator double() const  
{
	// la conversin a double devuelve el valor
	// de la hora en horas y decimales
	double resultado;
	resultado = horas + double ((minutos * 60 + segundos))  / 3600;
	return resultado;
}

 