// Archivo cap09.cpp
// Ejemplo de uso de clases
// Generacin de instancias
// Anlisis de constructores y destructores
//
#include <iostream>
#include "cempleado.h"
#include "cempleado1.h"
#include "cempleado2.h"
using namespace std;

void versionA();
Empleado * fun1A();
void fun2A();

void versionB();
Empleado1 * fun1B();
void fun2B(); 

void versionC();
Empleado2 * fun1C();
void fun2C(); 
int main()
{
	
	
	
	cout << "*****************************************\n";
	cout << "Programa cap09: Uso de memoria dinamica\n";
    cout << "*****************************************\n\n";
	 
	
	cout << "*****************************************\n\n";
	cout << "1ra. version A clase Empleado\n\n";
	cout << "*****************************************\n\n";
	versionA();

	cout << "*****************************************\n\n";
	cout << "2da. version B clase Empleado1\n";
	cout << "*****************************************\n\n";
	versionB();
	
    cout << "*****************************************\n\n";
	cout << "3ra. version C clase Empleado2\n";
	cout << "*****************************************\n\n";
	versionC();
	
	int final;
	cin >> final;
	 
}
void versionA()
{

	// Crea un objeto Empleado 
	// de mbito local
	cout << "Caso 1: clase Empleado (A)\n";
	Empleado e1("c1 Juan Salas",30);
	e1.mostrarDatos();

	// Ordena crear un Empleado
	// a otra funcin
	cout << "Caso 2: clase Empleado (A)\n";
	Empleado * ptr = fun1A();
	cout << "Vuelve de  fun1() \n";
	ptr->mostrarDatos();

	fun2A();
	cout << "Vuelve de fun2A() \n";

	// copia posterior a la construccin
	cout << "Caso 4: clase Empleado (A)\n";
	Empleado e4("c4 Ana Torroja",40);
	e4.mostrarDatos();

	cout << "Se copia objeto *ptr a e4 (ya existente)\n";    
	e4 = *ptr;
	e4.mostrarDatos();

	cout << "Caso 5: clase Empleado (A)\n";
	delete ptr;

	e4.mostrarDatos();

}
Empleado * fun1A()
{
	// Creacin en mbito local pero
	// con operador new
	cout << "Empieza  fun1A() \n";
	Empleado * e2 = new Empleado("c2 Sergio Candia", 8);
	e2->mostrarDatos();	
	return e2;

}
void fun2A()
{
	// Crea un objeto Empleado local
	cout << "Empieza  fun2A() \n";
	cout << "Caso 3: clase Empleado (A)\n";
	Empleado e3("c3 Carlos Santana",40);
	e3.mostrarDatos();

	// Crea otro objeto con el constructor
	// copia
	Empleado e3nuevo = e3;
	cout << "Se genera un objeto e3nuevo por copia de otro objeto\n";
	e3nuevo.mostrarDatos();

	cout << "Al salir de este bloque: 2 destrucciones\n";
	
}

void versionB()
{

	// Crea un objeto Empleado1 
	// de mbito local
	cout << "Caso 1: clase Empleado1 (B)\n";
	Empleado1 e1("c1 Juan Salas",30);
	e1.mostrarDatos();

	// Ordena crear un Empleado1
	// a otra funcin
	cout << "Caso 2: clase Empleado1 (B)\n";
	Empleado1 * ptr = fun1B();
	cout << "Vuelve de  fun1B() \n";
	ptr->mostrarDatos();

	fun2B();
	cout << "Vuelve de fun2B() \n";

	/*
	// copia posterior a la construccin
	cout << "Caso 4: clase Empleado1 (B)\n";
	Empleado1 e4("c4 Ana Torroja",40);
	e4.mostrarDatos();

	cout << "Se copia objeto *ptr a e4 (ya existente)\n";    
	e4 = *ptr;
	e4.mostrarDatos();

	cout << "Caso 5: clase Empleado1 (B)\n";
	*/
	delete ptr;

	//e4.mostrarDatos();*/

}
Empleado1 * fun1B()
{
	// Creacin en mbito local pero
	// con operador new
	cout << "Empieza  fun1B() \n";
	Empleado1 * e2 = new Empleado1("c2 Sergio Candia", 8);
	e2->mostrarDatos();	
	return e2;

}
void fun2B()
{
	// Crea un objeto Empleado1 local
	cout << "Empieza  fun2B() \n";
	cout << "Caso 3: clase Empleado1 (B)\n";
	Empleado1 e3("c3 Carlos Santana",40);
	e3.mostrarDatos();

	// Crea otro objeto con el constructor
	// copia predeterminado de C++

	// Paso3 A: si se ejecuta cancela el programa
	// este problema se corrige en la siguiente versin
	// de la clase
	/*Empleado1 e3nuevo = e3;
	
	cout << "Se genera un objeto e3nuevo por copia de otro objeto\n";
	e3nuevo.mostrarDatos();
	// fin paso 3A*/

	cout << "Al salir de este bloque: se esperan 2 destrucciones\n";
	cout << "Pero hace 1 porque saltamos el paso 3A dado que es incorrecto\n";
	
}
void versionC()
{

	// Crea un objeto Empleado2 
	// de mbito local
	cout << "Caso 1: clase Empleado2 (C)\n";
	Empleado2 e1("c1 Juan Salas",30);
	e1.mostrarDatos();

	// Ordena crear un Empleado2
	// a otra funcin
	cout << "Caso 2: clase Empleado2 (C)\n";
	Empleado2 * ptr = fun1C();
	cout << "Vuelve de  fun1C() \n";
	ptr->mostrarDatos();

	fun2C();
	cout << "Vuelve de fun2C() \n";

	// copia posterior a la construccin
	cout << "Caso 4: clase Empleado2 (C)\n";
	Empleado2 e4("c4 Ana Torroja",40);
	e4.mostrarDatos();

	cout << "Se copia objeto *ptr a e4 (ya existente)\n"; 
	cout << "Datos del objeto *ptr\n";
	ptr->mostrarDatos();
	e4 = *ptr;
	cout << "Datos del objeto e4 (post copia)\n";
	e4.mostrarDatos();



	cout << "Caso 5: clase Empleado2 (C)\n";
	delete ptr;

	cout << "Datos del objeto e4 (memoria de *ptr ya liberada)\n";
	e4.mostrarDatos();

}
Empleado2 * fun1C()
{
	// Creacin en mbito local pero
	// con operador new
	cout << "Empieza  fun1C() \n";
	Empleado2 * e2 = new Empleado2("c2 Sergio Candia", 8);
	e2->mostrarDatos();	
	return e2;

}
void fun2C()
{
	// Crea un objeto Empleado2 local
	cout << "Empieza  fun2C() \n";
	cout << "Caso 3: clase Empleado2 (C)\n";
	Empleado2 e3("c3 Carlos Santana",40);
	e3.mostrarDatos();

	// Crea otro objeto con el constructor
	// copia
	Empleado2 e3nuevo = e3;
	cout << "Se genera un objeto e3nuevo por copia de otro objeto\n";
	e3nuevo.mostrarDatos();

	cout << "Al salir de este bloque: debe haber 2 destrucciones\n";
	
}
