// Archivo cempleado2.cpp
// Clase Empleado2
//
#include <iostream>
#include <cstring>
#include "cempleado2.h"
using namespace std;

int Empleado2::instancias = 0;
Empleado2::Empleado2()  // constructor predeterminado
{
	longNombre = 19;
	nombre = new char[19]; 
	strcpy_s(nombre, 19, "No hay informacin");
 	horas_trabajadas = 0;
	instancias++;
	cout << "Se genera instancia con el constructor 1 "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado2\n\n";
}
Empleado2::Empleado2(const char * n, int ht)
{
	longNombre = strlen(n) + 1;
	nombre = new char [longNombre];
	strcpy_s(nombre,longNombre,n);
 	horas_trabajadas = ht;
	instancias++;
    cout << "Se genera instancia con el constructor 2 "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado2\n\n";
}
Empleado2::Empleado2(const Empleado2 & emp)
{
	longNombre = emp.longNombre + 1;
	nombre = new char[longNombre]; 
	strcpy_s(nombre,longNombre, emp.nombre);
 	horas_trabajadas = emp.horas_trabajadas;
	instancias++;
    cout << "Se genera instancia con el constructor copia "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado2\n\n";
}
Empleado2::~Empleado2()
{
	instancias--;
	cout << "Se destruye el objeto Empleado2 de " << nombre 
		<< ", quedan " << instancias  
		<< " ejemplares del objeto Empleado2\n\n";

	delete [] nombre;

	cout << "Y se libera la memoria del campo nombre\n\n";
}

void Empleado2::modificarHorasTrabajadas(int n)
{
	horas_trabajadas += n;
	cout << "Se actualizan las horas trabajadas de "
		<< nombre << "\n\n";
} 
void Empleado2::mostrarDatos() const
{
	cout << "Datos: empleado           " << nombre << "\n";
	cout << "- ptr this                " << this << "\n";
	cout << "- ptr a nombre            " << &nombre << "\n";
	cout << "- apuntado por ptr nombre " << (int *)nombre << "\n";
	cout << "- ptr a instancias        " << (int *)&instancias << "\n\n";
}
Empleado2 & Empleado2::operator=(const Empleado2 & emp) 
{
	// Se verifica que this y emp no
	// sean el mismo objeto
	if (&emp == this)
			return *this;
	delete [] nombre;
	longNombre = emp.longNombre + 1;
	nombre = new char[longNombre]; 
	strcpy_s(nombre,longNombre, emp.nombre);
 	horas_trabajadas = emp.horas_trabajadas;
	cout << "Se asigna un objeto a otro existente "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado2\n\n";
	return *this;
}
 

