// Archivo cap10.cpp
// Ejemplo de uso de clases
// Clases derivadas - Herencia 
//
#include <iostream>
#include "cempleado.h"
#include "cgerente.h"
using namespace std;

void casosherencia();
void casosvirtual(); 
 


int main()
{
	
	
	
	cout << "*****************************************\n";
	cout << "Programa cap10: Uso de clases derivadas\n";
    cout << "*****************************************\n\n";
	 
	
	cout << "*****************************************\n\n";
	cout << "Herencia \n\n";
	cout << "*****************************************\n\n";
	casosherencia();

	cout << "*****************************************\n\n";
	cout << "Func. virtuales\n\n";
	cout << "*****************************************\n\n";
	casosvirtual();

	 
	
	int final;
	cin >> final;
	 
}
void casosherencia()
{

	// Crea un objeto Empleado 
	// de mbito local
	cout << "Caso 1: clase Empleado (A)\n\n";
	Empleado emp1("emp1 Juan Salas",1200.50);
	emp1.mostrarDatos(0);
	emp1.modificarSalario(3000);

	// Ordena crear un Gerente
	cout << "Caso 2: clase Gerente (A)\n";
	Gerente * g2 = new Gerente("g2 Ana Salcedo", 24000, "ZONA SUR", 10000);
	g2->mostrarDatos(1);	
	 

	// Constructor conversin Empleado a Gerente
	cout << "Caso 3: Constructor para convertir Empleado a Gerente\n\n";
	// utilizamos el objeto Empleado (e1)
	emp1.mostrarDatos(1);
	Gerente  g3 = Gerente(emp1, "ZONA NORTE", 15000);
	g3.mostrarDatos(1);

    // Constructor copia Gerente a Gerente
	cout << "Caso 4: Constructor copia: objeto Gerente a objeto Gerente\n\n";
	Gerente g4 = Gerente("g4 Pedro Nicolau", 22000, "ZONA FRANCIA", 8000);
	g4.mostrarDatos(1);
	Gerente g5 = g4;
	g5.mostrarDatos(1);


	// debe permitir modificar este salario
	// porque el objeto es Gerente
	cout << "Caso 5: Modificar salario desde clase Gerente\n\n";
	g5.modificarSalario(120000);
	

	// Operador de asignacin
	cout << "Caso 6:  operador = (copia de un objeto a otro ya existente)\n\n";
	Gerente g6 = Gerente("g6 Antonio Font", 20000, "ZONA GALICIA", 9000);
	Gerente g7;
	g7 = g6;
	g7.mostrarDatos(0);

	// Creacin por conversin
	cout << "Caso 7:  convierte a Gerente\n\n";
	Gerente g8(emp1);
	g8.modificarNombre("g8 Emilio Justo");
	g8.mostrarDatos(0);

	
	delete g2;
}
void casosvirtual()
{
	//

	double dbl = 3.2;
	//short * ptrshr = &dbl;

	Empleado emp1("emp1 Juan Salas",1200.50);
	Gerente g9(emp1);

	// no hace falta cast
	// upcasting implcito
	Empleado * ptremp = &g9;
	Empleado & refemp = g9;
	
    // downcast, debe haber cast explcito
	Gerente * ptrger = (Gerente *)&emp1;
	Gerente & refger = (Gerente &)emp1;


	cout << "Loop \n";
	Empleado * ptr;
	for (int i = 1; i < 5; i++)
	{
		if (i % 2)
			ptr = new Empleado;
		else  
			ptr = new Gerente;
		ptr->mostrarDatos(0); 
		delete ptr;
	}

	// Comprobar la diferencia  
	// de comportamiento de una funcin 
	// declarada como no virtual y luego como
	// virtual 
	
	Empleado emp10("Justo Laguna",2300);
	Gerente g10("Perico Delgado",2100,"ZONA SEGOVIA",8000);
	// Al no usarse punteros
	// la llamada mostrarDatos() 
	// ser a la que corresponda al objeto 
	// invocante
	cout << "Caso 8:  Uso sin punteros\n\n";
	emp10.mostrarDatos(0);
	cout << "***************************\n";
	g10.mostrarDatos(0);

	cout << "Caso 9:  uso con punteros\n\n";
	Empleado * ptr1 = &emp10;
	ptr1->mostrarDatos(0);
	// El puntero es de tipo ptr a Empleado
	// pero ahora apuntar a un Gerente
	ptr1 = &g10;
	// si mostrarDatos() es virtual
	// se llamar a Gerente::mostrarDatos()
	// pero si no fuese virtual
	// se llamar a Empleado::mostrarDatos()
	cout << "***************************\n";
	ptr1->mostrarDatos(0);

	 
 
}
 
 