// Archivo cempleado.cpp
// Clase Empleado
//
#include <iostream>
#include <cstring>
#include "cempleado.h"
using namespace std;

int Empleado::instancias = 0;
Empleado::Empleado()  // constructor predeterminado
{
	char  n[] = "No hay datos del nombre";
	longNombre = strlen(n) +1;
	nombre = new char[longNombre]; 
	strcpy_s(nombre, longNombre, n);
 	salario = 0;
	instancias++;
	cout << "Se genera instancia con el constructor 1 "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado\n\n";
}
Empleado::Empleado(const char * n, double s)
{
	longNombre = strlen(n) + 1;
	nombre = new char [longNombre];
	strcpy_s(nombre,longNombre,n);
 	salario = s;
	instancias++;
    cout << "Se genera instancia con el constructor 2 "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado\n\n";
}
Empleado::Empleado(const Empleado & emp)
{
	longNombre = emp.longNombre + 1;
	nombre = new char[longNombre]; 
	strcpy_s(nombre,longNombre, emp.nombre);
 	salario = emp.salario;
	instancias++;
    cout << "Se genera instancia con el constructor copia "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado\n\n";
}
Empleado::~Empleado()
{
	instancias--;
	cout << "Se destruye el objeto Empleado de " << nombre 
		<< ", quedan " << instancias  
		<< " ejemplares del objeto Empleado\n\n";

	delete [] nombre;

	cout << "Y se libera la memoria del campo nombre\n\n";
}

void Empleado::modificarSalario(double s)
{
	if  (s <= SALARIOMAX)
	{
	salario = s; 
	cout << "Se actualiza el salario al nuevo valor "
		<< salario << "\n\n";
	}
	else
		cout << "El salario excede valor permitido "
		<< s << "\n\n";

}
void Empleado::modificarNombre(const char * n)
{
	delete [] nombre;
	longNombre = strlen(n) + 1;
	nombre = new char [longNombre];
	strcpy_s(nombre,longNombre,n);
	cout << "Se actualiza el nombre de "
		<< nombre << "\n\n";
} 
void Empleado::mostrarDatos(int i) const
{
	
	cout << "Datos: empleado             " << nombre << "\n";
	cout << "       salario              " << salario << "\n";
	if (i == 1)
	{
		cout << "- size del objeto  Empleado " << sizeof(Empleado) << "\n";
		cout << "- ptr this                  " << this << "\n";
		cout << "- ptr a nombre              " << &nombre << "\n";
		cout << "- apuntado por ptr nombre   " << (int *)nombre << "\n";
		cout << "- ptr a instancias          " << (int *)&instancias << "\n\n";
	}
}
Empleado & Empleado::operator=(const Empleado & emp) 
{
	// Se verifica que this y emp no
	// sean el mismo objeto
	if (&emp == this)
			return *this;
	delete [] nombre;
	longNombre = emp.longNombre + 1;
	nombre = new char[longNombre]; 
	strcpy_s(nombre,longNombre, emp.nombre);
 	salario = emp.salario;
	cout << "Se asigna un objeto a otro existente "
		<< ", hay " << instancias  
		<< " ejemplares del objeto Empleado\n\n";
	return *this;
}
 

