// Archivo cgerente.cpp
// Clase Gerente
//
#include <iostream>
#include <cstring>
#include "cgerente.h"
using namespace std;

int Gerente::instancias_gerente = 0;

// constructor  
Gerente::Gerente(const char * n , double s, 
				 const char * z, double p): Empleado(n,s)
{
	longZona = strlen(z) + 1;
	zona = new char [longZona];
	strcpy_s(zona,longZona,z);
 	plusObjetivos = p;
	instancias_gerente++;
    cout << "Se genera instancia con el constructor 2 "
		<< ", hay " << instancias_gerente  
		<< " ejemplares del objeto Gerente\n\n";
}
// Constructor conversin de Empleado a gerente
Gerente::Gerente(const Empleado & emp,
				 const char * z, double p): Empleado(emp)
{
	longZona = strlen(z) + 1;
	zona = new char [longZona];
	strcpy_s(zona,longZona,z);
 	plusObjetivos = p;
	instancias_gerente++;
    cout << "Se genera instancia con el constructor 3 "
		<< ", hay " << instancias_gerente  
		<< " ejemplares del objeto Gerente\n\n";
}
Gerente::Gerente(const Gerente & ger): Empleado(ger)  
{
	longZona = ger.longZona + 1;
	zona = new char[longZona]; 
	strcpy_s(zona,longZona, ger.zona);
 	plusObjetivos = ger.plusObjetivos;
	instancias_gerente++;
    cout << "Se genera instancia con el constructor copia "
		<< ", hay " << instancias_gerente  
		<< " ejemplares del objeto Gerente\n\n";
}
Gerente::~Gerente()
{
	instancias_gerente--;
	cout << "Se destruye el objeto Gerente de " << zona 
		<< ", quedan " << instancias_gerente  
		<< " ejemplares del objeto Gerente\n\n";

	delete [] zona;

	cout << "Y se libera la memoria del campo zona\n\n";
}

void Gerente::modificarPlusObjetivos(double p)
{
	plusObjetivos = p;
	cout << "Se actualiza el plus por objetivos de "
		<< zona << "\n\n";
}
void Gerente::modificarZona(const char * z)
{
	delete [] zona;
	longZona = strlen(z) + 1;
	zona = new char [longZona];
	strcpy_s(zona,longZona,z);
	cout << "Se actualiza la zona a "
		<< zona << "\n\n";
} 
void Gerente::mostrarDatos(int i) const
{
	Empleado::mostrarDatos(i);
	cout << "Datos: gerente              " << zona << "\n";
	cout << "       plus objetivos       " << plusObjetivos << "\n";
	if (i == 1)
	{
		cout << "- size del objeto Gerente   " << sizeof(Gerente) << "\n";
		cout << "- ptr this                  " << this << "\n";
		cout << "- ptr a zona                " << &zona << "\n";
		cout << "- apuntado por ptr zona     " << (int *)zona << "\n";	 
		cout << "- ptr a instancias_gerente  " << (int *)&instancias_gerente << "\n\n";
		
	}
}
Gerente & Gerente::operator=(const Gerente & ger) 
{
	// Se verifica que this y ger no
	// sean el mismo objeto

	if (&ger == this)
			return *this;
	Empleado::operator =(ger);
	delete [] zona;
	longZona = ger.longZona + 1;
	zona = new char[longZona]; 
	strcpy_s(zona,longZona, ger.zona);
 	plusObjetivos = ger.plusObjetivos;
	cout << "Se asigna un objeto a otro existente "
		<< ", hay " << instancias_gerente  
		<< " ejemplares del objeto Gerente\n\n";
	return *this;
}
void Gerente::modificarSalario(double s)
{
	salario = s; 
	cout << "Se actualiza el salario al nuevo valor "
		<< salario << "\n\n";
	
}