// Archivo cEmpleado.cpp
// Clase Empleado
// Ejemplo contencin
//
#include <iostream>
#include <string>
#include "cEmpleado.h"
using namespace std;

int Empleado::instancias = 0;

Empleado::Empleado(const Empleado & emp)
{
	nombre = emp.nombre; 
	salario = emp.salario;
	instancias++;
    cout << "Clase Empleado: constructor copia\n";
}
Empleado::~Empleado()
{
	instancias--;
	cout << "Clase Empleado: destructor nombre " << nombre << "\n";
	cout << "(quedan " << instancias << " objetos Empleado)\n\n";

}
double Empleado::totalSalarios()const
{
	return salario.totalSalarios();
}

void Empleado::modificarSalario(int i, double s)
{
	if  (s <= SALARIOMAX)
	{
	salario[i] = s; 
	cout << "Clase Empleado: Se actualiza el salario al nuevo valor "
		<< salario[i] << "\n\n";
	}
	else
		cout << "Clase Empleado: El salario excede valor permitido "
		<< s << "\n\n";

}
void Empleado::modificarNombre(const Texto & n)
{
	nombre.modificarTexto(n);
	cout << "Clase Empleado: modificarNombre a " << nombre << "\n";
	
} 
void Empleado::mostrarDatos(int i) const
{

	cout << "Clase Empleado: mostrarDatos\n";
	cout << "Datos: Empleado             " << nombre << "\n";
	cout << "       salario              " << salario << "\n";
	if (i == 1)
	{
		cout << "- size del objeto  Empleado " << sizeof(Empleado) << "\n";
		cout << "- ptr this                  " << this << "\n";
		cout << "- ptr a nombre              " << &nombre << "\n";
		nombre.mostrarDatos();
	}
}
Empleado & Empleado::operator=(const Empleado & emp) 
{
	// Se verifica que this y emp no
	// sean el mismo objeto
	if (&emp == this)
			return *this;
	nombre = emp.nombre;
	salario = emp.salario;
	cout << "Clase Empleado: operator=\n";
	return *this;
}
 

