// Archivo ctexto.cpp
// Clase Texto
//
#include <iostream>
#include "cTexto.h"
using namespace std;

int Texto::instancias = 0;
Texto::Texto()  // constructor predeterminado
{
	char  n[] = " ";
	longTexto = strlen(n) +1;
	texto = new char[longTexto]; 
	strcpy_s(texto, longTexto, n);
	instancias++;
	cout << "Clase Texto: constructor predeterminado\n";
	
 	
}
Texto::Texto(const char * n)
{
	longTexto = strlen(n) + 1;
	texto = new char [longTexto];
	strcpy_s(texto,longTexto,n);
	instancias++;
	cout << "Clase Texto: constructor desde char *\n";
}

Texto::Texto(const Texto & txt)
{
	longTexto = txt.longTexto;
	texto = new char[longTexto]; 
	strcpy_s(texto,longTexto, txt.texto);
	instancias++;
	cout << "Clase Texto: constructor copia\n";
 	 
}
Texto::~Texto()
{
	instancias--;
	cout << "Clase Texto: destruye " << *this << "\n";	
	cout << "Clase Texto: delete [] texto (quedan " << instancias << " objetos Texto)\n\n";	
	delete [] texto;
}


void Texto::modificarTexto(const Texto & txt)
{
	delete [] texto;
	longTexto = txt.longTexto;
	texto = new char [txt.longTexto];
	strcpy_s(texto,longTexto,txt.texto);
	cout << "Clase Texto: modificarTexto\n";
} 

void Texto::mostrarDatos() const
{
	cout << "Clase Texto " << texto << "\n";
	cout << "- long. texto  " << longTexto << "\n";
	cout << "- size del objeto  Texto " << sizeof(Texto) << "\n";
	cout << "- ptr this                  " << this << "\n";
	cout << "- ptr texto              " << (int *)texto << "\n\n";
		
}
Texto & Texto::operator=(const Texto & txt) 
{
	// Se verifica que this y emp no
	// sean el mismo objeto
	if (&txt == this)
			return *this;
	delete [] texto;
	longTexto = txt.longTexto;
	texto = new char [txt.longTexto];
	strcpy_s(texto,longTexto,txt.texto);
	cout << "Clase Texto: operator = " << texto << "\n";
	return *this;
}
 ostream & operator<<(ostream & o, const Texto & txt)
 {
	 o << txt.texto;
	 return o;
 }
 

