// Archivo cvectorsalario.cpp
// Clase VectorSalario
//
#include <iostream>
#include <string>
#include "cvectorsalario.h"
using namespace std;

int VectorSalario::instancias = 0;
VectorSalario::VectorSalario()  // constructor predeterminado
{
	cout << "Clase VectorSalario: constructor predeterminado\n";
	// se inicializa la matriz a ceros
	for (int i=0; i < LIMITE; i++)
		va[i] = 0;
	instancias++;
	
}

VectorSalario::VectorSalario(const double * s, int q) 
{
	cout << "Clase VectorSalario: constructor (double *, int)\n";
	if (q < 0 || q >= 12)
	{
		cout << "cantidad de elementos incorrecta: " << q << "\n";
		exit(1);
	}
	for (int i=0; i < LIMITE; i++)
		va[i] = 0;
	for (int i=0; i < q; i++)
		va[i] = s[i];
	instancias++;
    
}
VectorSalario::VectorSalario(const VectorSalario & vs)
{
	cout << "Clase VectorSalario: constructor copia\n"; 
	for (int i=0; i < LIMITE; i++)
		va[i] = vs.va[i];
	instancias++;
    
}
VectorSalario::~VectorSalario()
{
	instancias--;
	cout << "Clase VectorSalario: destructor nombre (quedan " << instancias << " objetos VectorSalario)\n\n";

}


double VectorSalario::totalSalarios() const
{
	cout << "Clase VectorSalario::totalSalario\n";
	double total = 0;
	for (int i=0; i < LIMITE; i++)
		total += va[i]; 
	return total;
}
void VectorSalario::mostrarDatos() const
{

	cout << "Clase VectorSalario: mostrarDatos\n";
	for (int i=0; i < LIMITE; i++)
	{
		cout << va[i]; 
		if (i%3)
			cout << "\n";
	}
	cout << "\n";

}
double & VectorSalario::operator[](int i) 
{
	cout << "Clase VectorSalario::operator[]\n";
	if (i < 1 || i > LIMITE)
	{
		cerr << "cantidad de elementos incorrecta: " << i << "\n";
		exit(1);
	}
	return va[i-1];
}
const double & VectorSalario::operator[](int i)const
{
	cout << "Clase VectorSalario::const operator[]\n";
	if (i < 1 || i > LIMITE)
	{
		cerr << "cantidad de elementos incorrecta: " << i << "\n";
		exit(1);
	}
	return va[i-1];
}

VectorSalario & VectorSalario::operator=(const VectorSalario & vs) 
{
	// Se verifica que this y vs no
	// sean el mismo objeto
	cout << "Clase VectorSalario::operator=\n";
	if (&vs == this)
			return *this;
	 
	for (int i=0; i < LIMITE; i++)
		va[i] = vs.va[i];
	return *this;
}
 
 
ostream & operator<<(ostream & o, const VectorSalario & vs)
{
	 
	o << "Clase VectorSalario: mostrarDatos\n";
	for (int i=0; i < vs.LIMITE; i++)
		o << " (Mes " << i+1 << ") " << vs.va[i] << "\n"; 
 	return o;
}
 
