#include "clista01.h"
#include "clista02.h"
#include "clista03.h"
#include "ctexto.h"
#include "cfriend.h"
#include <iostream>
#include "cdynamiccast.h"
#include <typeinfo>
using namespace std;

void test_dynamic_cast1();
void test_dynamic_cast2();


void main()
{

	// Caso ListaT (typedef)
	cout << "Caso ListaT (typedef) \n"; 
	ListaT lst1;
	lst1.colocar(6);
	lst1.colocar(5);
	lst1.colocar(7);
	Tipo x1(5);
	lst1.quitar(x1);
	lst1.verLista();

	// Caso ListaG (template con double)
	cout << "********************\n\n"; 
	cout << "Caso ListaG (template con double) \n"; 
	ListaG <double> lst2;
	lst2.colocar(6);
	lst2.colocar(5);
	lst2.colocar(7);
	double x2(5);
	lst2.quitar(x2);
	lst2.verLista();

	// Caso ListaG (template con int)
	cout << "********************\n\n";
	cout << "Caso ListaG (template con int) \n"; 
	ListaG <int> lst3;
	lst3.colocar(6);
	lst3.colocar(5);
	lst3.colocar(7);
	double x3(5);
	lst3.quitar(x3);
	lst3.verLista();

	// Caso ListaG (template con Texto)
	cout << "********************\n\n";
	cout << "Caso ListaG (template con Texto) \n"; 
	Texto txt("Hola");
	ListaG <Texto> lst4;
	lst4.colocar(txt);
	lst4.colocar("Chau");
	lst4.colocar("Chau2");
	lst4.colocar("Chau3");
	lst4.quitar(txt);
	lst4.quitar(Texto("Chau2"));
	lst4.verLista();


	// Caso ListaG (template con puntero a int)
	cout << "********************\n\n";
	cout << "Caso ListaG (template con puntero a int) \n"; 
	ListaG <int *> lst5;
	int x = 9;
	int y = 5;
	int z = 8;	
	lst5.colocar(&y);
	lst5.colocar(&z);
	lst5.quitar(&z);
	lst5.colocar(&x);
	lst5.verLista();

	// Caso ListaG2 (template con dos argumentos)
	cout << "********************\n\n";
	cout << "Caso ListaG2 (template con dos argumentos) \n"; 
	ListaG2 <int, 8> lst6;
	lst6.colocar(2222);	
	lst6.colocar(3333);
	lst6.colocar(4444);
	lst6.quitar(3333);
	lst6.verLista();


	// Caso Templates y friend
	cout << "********************\n\n";
	cout << "Caso template y friend \n"; 
	A<int> xa;
	B<int> xb;
	xb.mod(xa, 6);
	cout << xa.verVar1() << "\n";

	// Caso dynamic_cast
	test_dynamic_cast1();


	int j;
	cin >> j;
}
void test_dynamic_cast1()
{		
	// Caso dynamic_cast
	Persona * ptr;
	Empleado * ptre;
	Gerente * ptrg;
	for (int i = 1; i < 4; i++)
	{
		
		switch (i)
		{
		case 1:
			ptr = new Persona(i);
			break;
		case 2:
			ptr = new Empleado(i);
			break;	
		case 3:
			ptr = new Gerente(i);
			break;
		}
		cout << "Caso " << i << ": Objeto de tipo " << typeid(*ptr).name() << "\n";
		// todos caminan
		ptr->caminar();

		// Empleados y Gerentes trabajan
		if (ptre = dynamic_cast<Empleado *>(ptr))
			ptre->trabajar();

		// Slo Gerentes mandan
		if (ptrg = dynamic_cast<Gerente *>(ptr))
			ptrg->mandar();

		cout << "------\n";
	}
}
 