#include <string>
#include <iostream>
#include "meteo.h"
#include <iomanip>
#include <fstream>
#include <string>

using namespace std;

int ejemplo01();
int grabarArchivoTexto();
int leerArchivoTexto();
int grabarArchivoBinario();
int leerArchivoBinario();
int grabarArchivoBinarioBloque();
int leerArchivoBinarioBloque();
int accesoDirecto();


int main()
{
 	 //ejemplo01();

	 // modo Texto
	 //grabarArchivoTexto();

	 //leerArchivoTexto();

	 // modo binario
	 //grabarArchivoBinario();

	 //leerArchivoBinario();

	 // modo binario en bloques
	 //grabarArchivoBinarioBloque();

	 //leerArchivoBinarioBloque();

	 // Acceso directo
	 accesoDirecto();

	 int j;
	 cin >> j;
}
int ejemplo01()
{

	 Meteo m(20.5, 40, 65, 1024, 5);

	 cout << m << "\n";


	 cin >> m;
	 
	 cout << m;


	 // ejemplo manipuladores
	 cout << setprecision(6)  << 5000.56788 <<endl;
	 cout << setw(6) << "Y ahora ..." << 400.56780 <<endl;

	 return 0;
}
int leerArchivoTexto()
{
	cout << "leerArchivoTexto\n";
	// Se abre un archivo "TestTexto"
	// para leer datos de pruebas
	ifstream archivo("TestTexto");

	// si no se puede abrir
	// retornar con valor 4 
	// funcin is_open() para verificar
	// si el archivo est abierto
	if (!archivo.is_open()) {
		cout << "No se pudo abrir el archivo TestTexto\n";
	    return 4;
	}
	// lectura de un archivo de texto
	char str[50];
	while (!archivo.eof()){
		archivo.getline(str,50);
		cout << str << "\n";
	}

	
	// cerrar el archivo
	archivo.close();
	return 0;

}
int grabarArchivoTexto()
{
	cout << "grabarArchivoTexto\n";

	// Se abre un archivo "TestTexto"
	// para escribir datos de pruebas
	ofstream archivo("TestTexto");

	// si no se puede abrir
	// retornar con valor 4 
	// una manera de preguntar si
	if (!archivo) {
		cout << "No se pudo abrir el archivo TestTexto\n";
	    return 4;
	}
	// escritura de un archivo de texto
	archivo << "Este es un texto...\n";

	// se descarga el bfer para forzar
	// la escritura
	archivo.flush();

	archivo << "de prueba1...\n";
	archivo << "de prueba2...\n";
	archivo << "de prueba3...\n";

	// cerrar el archivo
	archivo.close();
	return 0;

}
int leerArchivoBinario()
{
	cout << "leerArchivoBinario\n";

	// Se abre un archivo "TestBin"
	// para leer datos de pruebas
	ifstream archivo("TestBin", ios::in | ios::binary);

	// si no se puede abrir
	// retornar con valor 4 
	if (!archivo.is_open()) {
		cout << "No se pudo abrir el archivo TestBin\n";
	    return 4;
	}

	// lectura de un archivo binario
	char c;
	cout << "Uso de get\n";
	while (archivo) {
		archivo.get(c);
		if (archivo) cout << c;
	}
	cout << "\n";

	// cerrar el archivo
	archivo.close();
	return 0;

}
int grabarArchivoBinario()
{
	cout << "grabarArchivoBinario\n";

	// Se abre un archivo "TestBin"
	// para escribir datos de pruebas
	ofstream archivo("TestBin", ios::out | ios::binary);

	// si no se puede abrir
	// retornar con valor 4 
	if (!archivo.is_open()) {
		cout << "No se pudo abrir el archivo TestBin\n";
	    return 4;
	}
	// escritura de un archivo binario
	char * ptr = "Texto que se escribe en modo binario";
	cout << "Uso de put\n";
	while(*ptr){
		cout << *ptr;
		archivo.put(*ptr++);
	}
    cout << "\n";

	// cerrar el archivo
	archivo.close();
	return 0;
}
int leerArchivoBinarioBloque()
{
	cout << "leerArchivoBinarioBloque\n";

	// Se abre un archivo "TestBinBloque"
	// para leer datos de pruebas
	ifstream archivo("TestBinBloque", ios::in | ios::binary);

	// si no se puede abrir
	// retornar con valor 4 
	if (!archivo) {
		cout << "No se pudo abrir el archivo TestBinBloque\n";
	    return 4;
	}

	// lectura de un bloque de archivo binario
	char buf[1000];
	cout << "Uso de read\n";

	// se lee el bloque y se carga el contenido de la matriz
	archivo.read((char *) &buf, sizeof buf); 
		
	// se lista parte del contenido de la matriz
	for (int i = 0; i < 100 ; i++) cout << buf[i];
	cout << "\n";
	// cerrar el archivo
	archivo.close();
	return 0;

}
int grabarArchivoBinarioBloque()
{
	cout << "grabarArchivoBinarioBloque\n";

	// Se abre un archivo "TestBinBloque"
	// para escribir datos de pruebas
	ofstream archivo("TestBinBloque", ios::out | ios::binary);

	// si no se puede abrir
	// retornar con valor 4 
	if (!archivo) {
		cout << "No se pudo abrir el archivo TestBinBloque\n";
	    return 4;
	}
	char buf[1000];
	// se genera el contenido de prueba de la matriz
	int j;
	for (int i= 0; i < sizeof buf; i++){
		// asignamos de A a Z
		j = i % 26 + 65;
		buf[i] = char(j);
	}

	// escribe un bloque completo de longitud 1000
	cout << "Uso de write\n";
	archivo.write((char *) &buf, sizeof buf);	

	// Veamos parte del contenido de la matriz en memoria
    for (int i = 0; i < 100; i++) cout << buf[i];
	cout << "\n";

	// cerrar el archivo
	archivo.close();
	return 0;
}
int accesoDirecto()
{
	cout << "accesoDirecto\n";

	// Se abre el archivo "TestBinBloque"
	// para leer y escribirdatos de pruebas
	fstream archivo("TestBinBloque", ios::in | ios::out, ios::binary);

	// si no se puede abrir
	// retornar con valor 4 
	if (!archivo) {
		cout << "No se pudo abrir el archivo TestBinBloque\n";
	    return 4;
	}

	int pos;
	char c;
	cout << "Elegir pos. de lectura directa: ";
	cin >> pos;

	// posicionamiento dentro del archivo
	archivo.seekg(pos, ios::beg);

	// datos encontrados
	if (archivo.get(c))cout << "Encuentra este valor: " << c << "\n";
	
	// se reemplaza el dato
	archivo.seekp(pos, ios::beg);
	archivo.put('9');

	// comprobar el nuevo contenido
	archivo.seekg(pos, ios::beg);

	// datos modificados
	if (archivo.get(c))cout << "Nuevo valor " << c << "\n";
	
	// cerrar el archivo
	archivo.close();
	return 0;

}