// Iteradores y contenedores STL
#include <iterator>
#include <vector>
#include <algorithm>
#include <iostream>
#include <list>
#include <set>
#include <map>
#include <string>
using namespace std;

void iteradores01();
void iteradores02();
void Listar(int);
void contenedor_secuencia_list();
void contenedor_asociativo_multiset();
void contenedor_asociativo_map();
void functors01();
void functors02();
void functors03();

// predicado binario para algoritmo sort
bool descendente ( int i1, int i2 ){return i1 > i2;}
bool ascendente ( int i1, int i2 ){return i1 < i2;}

// predicado eliminacin de los pares de una lista
bool eliminarPares ( int i1){
	return (i1 % 2 == 0);
}
 


int main( )
{
   	//iteradores01();

	//iteradores02();

	//contenedor_secuencia_list();
	//contenedor_asociativo_multiset();
	//contenedor_asociativo_map();

	//functors01();
	//functors02();

	functors03();

   int j;
   cin >> j;
}

void iteradores01()
{


   // Creacin del vector y su iterador
   vector<int> vec(3);
   vector <int>::iterator iter_entrada;

   cout << "Entrar  3 nros. separados por espacios en blanco \n";
   cout << "finalizar con cualquier letra para provocar el fin de la entrada\n";
   istream_iterator<int> miVector ( cin );
    
 
   // Copia la entrada que qued en miVector
   // en el vector vec
   // Se comprueba con final de la secuencia
   // el segundo argumento representa fin de la secuencia 
   copy ( miVector , istream_iterator<int>( ) , vec.begin ( ) );

   // El iterador itr_salida 
   ostream_iterator <int, char> iter_salida(cout, "\n");
   // se recorre el vecto vec para copiarlo en 
   // cout mediante el iterador de salida
   cout << "Listado usando iter_salida como cout\n";
   copy ( vec.begin(), vec.end() , iter_salida);
 
     cout << "Listado con iterador de entrada\n";   
   for ( iter_entrada = vec.begin( ) ; iter_entrada != vec.end( ) ; iter_entrada++ )
      cout << *iter_entrada << " "; cout << endl;
      
  
}
void iteradores02()
{
	int mat1[5] = {10, 20, 30, 40, 50};
	int mat2[] = {100, 200, 300, 400};
	int mat3[] = {0, 5, 15};

	vector<int> vector01(5);

	// se copia la matriz en el vector
	copy(mat1, mat1+5, vector01.begin());

	// se lista el contenido del vector
	// con un iterador ostream_iterator
	ostream_iterator<int> salida(cout, " ");
	cout << "desp. de crear el vector\n";
	copy(vector01.begin(), vector01.end(), salida);
	cout << "\n\n";

	
	// insercin al final del contenedor
	back_insert_iterator<vector<int>> miIterador1(vector01);
	copy(mat2, mat2+4, miIterador1);
	cout << "desp. de back_insert_iterator\n";
	copy(vector01.begin(), vector01.end(), salida);
	cout << "\n\n";
	
	// insercin al principio
	insert_iterator<vector<int>> miIterador2(vector01, vector01.begin());
	copy(mat3, mat3+3, miIterador2);
	cout << "desp. de insert_iterator\n";
	copy(vector01.begin(), vector01.end(), salida);
	cout << "\n\n";

	cout << "lectura con reverse_iterator\n";
	vector<int>::reverse_iterator miIterador3;
	for (miIterador3 = vector01.rbegin();
		miIterador3 != vector01.rend();
		++miIterador3)
		cout << *miIterador3 << " ";
	cout << "\n\n";


	cout << "Lista con for_each\n";
	for_each(vector01.begin(), vector01.end(), Listar);


}
void contenedor_secuencia_list()
{
	ostream_iterator<int> salida(cout, " ");

	// crea una lista de 10 elementos 999
	list<int> list01(10, 4);

	// una matriz
	int mat[] = {10, 3, 30, 2, 30, 1};
		
	// crea una lista vaca
	list<int> list02;

	// crea la lista list03 
	list<int> list03(5, 7);

	// inserta la matriz en la lista list02
	cout << "insert list02\n";
	list02.insert(list02.begin(), mat, mat+6);
	copy(list02.begin(), list02.end(), salida);
	cout << endl;

	// elimina los elementos con el valor 30
    cout << "remove list02\n";
	list02.remove(30);
	cout << endl;


	// ordenar la lista
	cout << "sort list02\n";
	list02.sort();
	copy(list02.begin(), list02.end(), salida);
	cout << endl;

	// combina dos listas
	cout << "merge list02 y list03\n";
	list03.merge(list02);
	copy(list03.begin(), list03.end(), salida);
	cout << endl;

	// insercin de una lista en otra
	cout << "splice list01\n";
	// crea la lista list04 
	list<int> list04(3, 99);
	copy(list01.begin(), list01.end(), salida);
	cout << endl;
	copy(list04.begin(), list04.end(), salida);
	cout << endl;
	list01.splice(list01.begin(), list04);
	copy(list01.begin(), list01.end(), salida);
	cout << endl;


}
void contenedor_asociativo_multiset()
{
	ostream_iterator<int> salida(cout, " ");

	// una matriz
	// hay duplicados en mat2, por eso se usar
	// multiset y no set
	int mat1[] = {10, 3, 30, 2, 30};
	int mat2[] = {10, 2, 50, 2, 70};

	// crea conjuntos set
	multiset<int> set1(mat1, mat1 + 5);
	multiset<int> set2(mat2, mat2 + 5);

	// ver el contenido de los contenedores
	cout << "Contenido de set1: ";
	copy (set1.begin(), set1.end(), salida);
	cout << endl << endl;
	cout << "Contenido de set2: ";
	copy (set2.begin(), set2.end(), salida);
	cout << endl << endl;

	cout << "set_difference set1 y set2: ";
	set_difference(set1.begin(), set1.end(),
		set2.begin(), set2.end(), 
		salida);
	cout << endl << endl;

	cout << "set_symmetric_difference set1 y set2: ";
	set_symmetric_difference(set1.begin(), set1.end(),
		set2.begin(), set2.end(), 
		salida);
	cout << endl << endl;
	
	cout << "Intersection set1 y set2: ";
	set_intersection(set1.begin(), set1.end(),
		set2.begin(), set2.end(), 
		salida);
	cout << endl << endl;


	cout << "Union set1 y set2: ";
	set_union(set1.begin(), set1.end(),
		set2.begin(), set2.end(), 
		salida);
	cout << endl << endl;

	cout << "Crear set3: ";
	multiset<int> set3;
	insert_iterator<multiset<int>> miIterador(set3,set3.begin());
	set_intersection(set1.begin(), set1.end(),
		set2.begin(), set2.end(), 
		miIterador);
	copy(set3.begin(), set3.end(), salida);
	cout << endl << endl;

	cout << "Listar un rango de valores de set3: ";
	copy(set3.lower_bound(5), set3.end(), salida);
	cout << endl << endl;
	 
}
void contenedor_asociativo_map()
{
	
	//Mapa miMapa;
	multimap<int, string> miMapa;

	miMapa.insert(pair<int, string>(17480, "Roses"));
	miMapa.insert(pair<int, string>(17480, "Santa Margarida"));
	miMapa.insert(pair<int, string>(8860, "Castelldefels"));
	miMapa.insert(pair<int, string>(8007, "BCN"));
	miMapa.insert(pair<int, string>(28000, "Madrid"));

	multimap<int, string>::iterator it1;
	for (it1 = miMapa.begin(); it1 != miMapa.end(); ++it1)
		cout << (*it1).first << " : " << (*it1).second << endl;

	cout << "Cantidad de ciudades c.p. 17480 = " <<
		miMapa.count(17480) << endl;

}
void functors01()
{
	ostream_iterator<int> salida(cout, " ");

	// una matriz cualquiera
	int mat[] = {66, 13, 310, 2, 230, 11};
		
	// crea una lista vaca
	vector<int> vector01(6);
	copy(mat, mat+6, vector01.begin());
	cout << "Antes del sort: ";
	copy(vector01.begin(), vector01.end(), salida);
	
	// predicado binario ascendente
	sort(vector01.begin(), vector01.end(), ascendente); 
	cout << "\n\nDesp. del sort ascendente: ";
	copy(vector01.begin(), vector01.end(), salida);

	// predicado binario descendente
	sort(vector01.begin(), vector01.end(), descendente); 
	cout << "\n\nDesp. del sort descendente: ";
	copy(vector01.begin(), vector01.end(), salida);

	// predicado binario descendente predefinido
	sort(vector01.begin(), vector01.end(), greater<int>()); 
	cout << "\n\nDesp. del sort descendente greater<int>(): ";
	copy(vector01.begin(), vector01.end(), salida);
	 
}

void functors02()
{
	ostream_iterator<int> salida(cout, " ");

	// una matriz
	int mat[] = {10, 3, 30, 2, 30, 1};
		
	list<int> list01(1);

	// inserta la matriz en la lista list01
	cout << "copiar mat en list01\n";
	list01.insert(list01.begin(), mat, mat+6);
	cout << endl;

	cout << "Antes de eliminar de los pares :";
	copy(list01.begin(), list01.end(), salida);
	cout << endl << endl;

	list01.remove_if(eliminarPares);

	cout << "Desp. de eliminar los pares :";
	copy(list01.begin(), list01.end(), salida);
	cout << endl << endl;


}
void functors03()
{
	ostream_iterator<int> salida(cout, " ");

	// una matriz cualquiera
	int mat1[] = {66, 13, 310, 2, 230, 11};
	int mat2[] = {26, 2, 6, 8, 10, 15};
		
	// crea una lista vaca
	vector<int> vector01(mat1, mat1+6);
	vector<int> vector02(mat2, mat2+6);

	cout << "\nMultiplica dos vectores: ";
	transform(vector01.begin(), vector01.end(),
			  vector02.begin(), salida, multiplies<int>());



}
void Listar(int valor)
{
	// Lista con cout
	cout << valor << "-";
}
